unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, StdCtrls, TeEngine, Series, TeeProcs, Chart,
  ExtCtrls, TeeComma, Buttons, TeeSurfa, TeePoin3;

type
  TForm1 = class(TForm)
    TeeCommander1: TTeeCommander;
    Chart1: TChart;
    Series1: TPoint3DSeries;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    BitBtn1: TBitBtn;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TxtXRange: TEdit;
    TxtYRange: TEdit;
    TxtZRange: TEdit;
    Button7: TButton;
    BitBtn3: TBitBtn;
    CheckBox1: TCheckBox;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    RB3: TRadioButton;
    RB2: TRadioButton;
    RB1: TRadioButton;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Chart1AfterDraw(Sender: TObject);
    procedure LocalMinMax(series : TChartSeries; first, last : Integer; var min  : double; var max : double);
    procedure FormCreate(Sender: TObject);
    procedure makeEqualScales;
    procedure makeXDomScale;
    procedure makeYDomScale;
    procedure makeZDomScale;
    procedure Button2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure RB3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hasPainted : Boolean;

Const pi = 3.14159265358;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  hasPainted := False;
  Chart1.BottomAxis.setMinMax(Chart1.BottomAxis.Minimum-10,Chart1.BottomAxis.Maximum-10);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  hasPainted := False;
  Chart1.BottomAxis.setMinMax(Chart1.BottomAxis.Minimum+10,Chart1.BottomAxis.Maximum+10);
end;

procedure TForm1.Chart1AfterDraw(Sender: TObject);
var first,last:Integer;
   min, max : double;
begin
  first := Series1.FirstDisplayedIndex;
  last := Series1.LastDisplayedIndex;
  Chart1.Canvas.TextOut(10,10, 'first: ' + IntToStr(first) + ', last: ' + IntToStr(last) );

  if (not hasPainted) and (Series1.Count > 0) then
  Begin
    LocalMinMax(Series1, first, last, min, max);
    Chart1.LeftAxis.setMinMax(min,max);
    hasPainted := True;
    Chart1.Draw;
  end;
end;


procedure TForm1.LocalMinMax(series : TChartSeries; first, last : Integer; var min  : double; var max : double);
var i: integer;
Begin
      min := series1.YValues[first];
      max := series1.YValues[first];
      for i := first to last -1 do
      begin
        if (series1.YValues[i] < min) then min := series.YValues[i];
        if (series1.YValues[i] > max) then max := series.YValues[i];
      end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Series1.Fillsamplevalues(200);
 // Series1.Stairs := true;
//  Chart1.BottomAxis.setMinMax(90,120);

  Chart1.Chart3DPercent := 45;
  CheckBox1.Checked :=Chart1.View3DOptions.Orthogonal;
  Chart1.Axes.Bottom.LabelsAngle := 90;
  RB3Click(Self);
  hasPainted := False;
end;

procedure MakeISOAxes(AChart:TCustomChart);
Var xPixSize, yPixSize, zPixSize: double;
XRange, YRange, ZRange : Double;
pxXRatio, pxYRatio, pxZRatio : Double;
xmax, ymax, zmax, ConDegRev, tanAngle : Double;
smallestRatio : double;

Begin
  With AChart do
  Begin

    xPixSize := Axes.Bottom.IEndPos - Axes.Bottom.IStartPos;
    yPixSize := Axes.Left.IEndPos - Axes.Left.IStartPos;

    //depth axis - trig it(although could use root of squares of sides as always equi-45 triangle).
    ConDegRev := 180 / pi;

    tanAngle := Abs(arctan((Height3D) / (Width3D)) * ConDegRev);
    //tmpp := Sin(tanAngle / ConDegRev);
    zPixSize := Height3D / Sin(tanAngle / ConDegRev);

    With Axes.Bottom do
	Begin
      XRange := Maximum - Minimum;
      //xmax := Maximum;
      pxXRatio := xPixSize / XRange;
    end;
    With Axes.Left do
	Begin
      YRange := Maximum - Minimum;
      //ymax := Maximum;
      pxYRatio := yPixSize / YRange;
    End;
    With Axes.Depth do
	Begin
      ZRange := Maximum - Minimum;
      //zmax := Maximum;
      pxZRatio := zPixSize / ZRange;
    End;

    smallestRatio := pxXRatio;

    If pxYRatio < smallestRatio Then
      smallestRatio := pxYRatio;

    If pxZRatio < smallestRatio Then
      smallestRatio := pxZRatio;

    xmax := xPixSize / smallestRatio;
    ymax := yPixSize / smallestRatio;
    zmax := zPixSize / smallestRatio;

    With Axes.Bottom do
	Begin
      SetMinMax(Minimum, xmax);
      Increment := 50;
    End;
    With Axes.Left do
	Begin
      SetMinMax(Minimum, ymax);
      Increment := 50;
    End;
    With Axes.Depth do
	Begin
      SetMinMax(Minimum, zmax);
      Increment := 50;
    End;
  End;
End;

procedure MakeIsoAxisOld(AChart:TCustomChart);  overload;
var tmpX,tmpY,XRange,YRange,Offset,XYScreen:Double;
begin
  With AChart do
  if (ChartHeight>0) and (ChartWidth>0) then
  begin
    With BottomAxis do XRange:=Maximum-Minimum;
    With LeftAxis do YRange:=Maximum-Minimum;

    XYScreen:=1.0*(GetDeviceCaps(Canvas.Handle,HORZSIZE)/Screen.Width)/
(GetDeviceCaps(Canvas.Handle,VERTSIZE)/Screen.Height);

    tmpX:=(XRange/ChartWidth);
    tmpY:=(YRange/ChartHeight)*XYScreen;

    if tmpX>tmpY then
    begin
      if tmpY<>0 then
      begin
        Offset:=((YRange*tmpX/tmpY)-YRange)/2.0;
        With LeftAxis do SetMinMax(Minimum-Offset,Maximum+Offset);
      end;
    end
    else
    if tmpX<>0 then
    begin
      Offset:=((XRange*tmpY/tmpX)-XRange)/2.0;
      With BottomAxis do SetMinMax(Minimum-Offset,Maximum+Offset);
    end;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Chart1.Axes.Left.Increment := 50;
  Chart1.Axes.Bottom.Increment := 50;
  Chart1.Axes.Depth.Increment := 50;

  if Series1.count > 0 then
    MakeIsoAxes(Chart1);

  RB3Click(Self);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
Begin
  Chart1.Axes.Left.Increment := 50;
  Chart1.Axes.Bottom.Increment := 50;
  Chart1.Axes.Depth.Increment := 50;

  if Series1.count > 0 then
    MakeISOAxisOld(Chart1);
end;

procedure TForm1.makeEqualScales;
var x, z : Integer;
begin

  Chart1.Series[0].Clear;
  Chart1.Axes.Left.Automatic := True;
  Chart1.Axes.Bottom.Automatic := True;
  Chart1.Axes.Depth.Automatic := True;

  //50x50x50
  For x := 1 to 50 do
    For z := 1 to 50 do
      Series1.AddXYZ(x, Random(50), z, '', clTeeColor);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  makeEqualScales;
end;

procedure TForm1.makeXDomScale;
var x, z : Integer;
begin

  Chart1.Series[0].Clear;
  Chart1.Axes.Left.Automatic := True;
  Chart1.Axes.Bottom.Automatic := True;
  Chart1.Axes.Depth.Automatic := True;

  //150x50x50
  For x := 1 to 150 do
    For z := 1 to 50 do
      Series1.AddXYZ(x, Random(50), z, '', clTeeColor);
end;

procedure TForm1.makeYDomScale;
var x, z : Integer;
begin

  Chart1.Series[0].Clear;
  Chart1.Axes.Left.Automatic := True;
  Chart1.Axes.Bottom.Automatic := True;
  Chart1.Axes.Depth.Automatic := True;

  //50x150x50
  For x := 1 to 50 do
    For z := 1 to 50 do
      Series1.AddXYZ(x, Random(150), z, '', clTeeColor);
end;

procedure TForm1.makeZDomScale;
var x, z : Integer;
begin

  Chart1.Series[0].Clear;
  Chart1.Axes.Left.Automatic := True;
  Chart1.Axes.Bottom.Automatic := True;
  Chart1.Axes.Depth.Automatic := True;

  //50x50x150
  For x := 1 to 50 do
    For z := 1 to 150 do
      Series1.AddXYZ(x, Random(50), z, '', clTeeColor);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  makeXDomScale;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  makeYDomScale;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  makeZDomScale;
end;

procedure TForm1.Button7Click(Sender: TObject);
var x, z : Integer;
begin

  Chart1.Series[0].Clear;
  Chart1.Axes.Left.Automatic := True;
  Chart1.Axes.Bottom.Automatic := True;
  Chart1.Axes.Depth.Automatic := True;

  //50x50x150
  For x := 0 to StrToInt(txtXRange.Text) do
    For z := 0 to StrToInt(txtZRange.Text) do
      Series1.AddXYZ(x, Random(StrToInt(txtYRange.Text)), z, '', clTeeColor);

end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Chart1.View3DOptions.Orthogonal := CheckBox1.Checked;
end;

procedure TForm1.RB3Click(Sender: TObject);
begin
  if (sender = RB1) or (RB1.Checked) then
  Begin
    Chart1.Axes.Left.Increment := 10;
    Chart1.Axes.Bottom.Increment := 10;
    Chart1.Axes.Depth.Increment := 10;
  end
  else if  (sender = RB2)  or (RB2.Checked) then
  Begin
    Chart1.Axes.Left.Increment := 20;
    Chart1.Axes.Bottom.Increment := 20;
    Chart1.Axes.Depth.Increment := 20;
  end
  else if  (sender = RB3)  or (RB3.Checked) then
  Begin
    Chart1.Axes.Left.Increment := 50;
    Chart1.Axes.Bottom.Increment := 50;
    Chart1.Axes.Depth.Increment := 50;
  end
end;

end.
